Subject: Re: r8169: is the work queue is initialized at wrong place?

From: Peter Wu <[email-masked]>
Date: Sun, 21 Jul 2013 01:22:29 +0200

On Thursday 18 July 2013 23:53:43 Francois Romieu wrote:
> Peter Wu <[email-masked]> :
> [...]
> 
> > However, this queue is only initialized in rtl_open:
> > 
> > 6673         INIT_WORK(&tp->wk.work, rtl_task);
> > 6674
> > 6675         smp_mb();
> > 
> > Shouldn't this INIT_WORK be done in rtl_init_one ?
> 
> (or cancel_work_sync in rtl8169_close to reduce the scope)
> 
> I do not see how the current code could hurt but it's really ugly.
> 
> > I do not know what this smp_mb is used for in this context, so I leave
> > an appropriate patch up to you.
> 
> It does not cost much and it enforces an initialized state. IRQ - real
> or shared ones - and napi poll could happen really soon after this point.
> There is probably some implicit memory barrier the driver could rely on.
> It would be a bit hackish though.
> 
> I'll check the history and cook a patch.

Just to let you know, I am working on a patch since I encountered a 
different(related?) issue that spams the syslog.The patch and partial analysis 
is ready but untested.

Regards,
Peter